#!/usr/bin/env ruby
#
# Author: SAKIMA Kimihisa
# Contact: sakima@hooktail.org
# Date: $Date: 2005-07-24 18:15:46 $
#
#
# ̾
#  kagipdfAtAt.rb
#
# 
#  kagipdfAtAt.rb < STDIN
#
# 
#   @@ ̿
#
# ToDo
#   * @@reference:@@ б
#
############################################################

# STDIN ԤˤޤȤ
content = readlines.join



###
###  @@...@@פγƼѥ
###

$authorPat = /@@author:\s*(.*?)\s*@@/
$datePat = /@@accept:\s*(.*?)\s*@@/
$referencePat = /@@reference:\s*(.*?)\s*@@/
$categoryPat = /@@category:\s*(.*?)\s*@@/



###
###  ѥ˥ޥåʬ
###

author = content.scan($authorPat).join
date = content.scan($datePat).join



###
### @@author:...@@ס@@accept:...@@פ
###  줾쥿ȥľΡ:Author: ...,:Date: ...פѴ
###

if content =~ $authorPat
  content = content.sub(/\n(.*)(====|----|````|::::|\"\"\"\"|~~~~|\^\^\^\^|____|\*\*\*\*|\+\+\+\+|####|<<<<|>>>>)\n/) { "\n" + $1 + $2 +  "\n:Author: " + author + "\n" + ":Date: " + date + "\n\n\n" }
end 



###
### @@...@@פΤΤϼ
###

content = content.gsub($authorPat, "").\
                  gsub($datePat, "").\
                  gsub($referencePat, "").\
                  gsub($categoryPat, "")



###
### footnote Ͽ
###

content = content.gsub(/ \[\*\]\_ ?/, " \[#\]\_ ")\
                 .gsub(/^\.\.\s+\[\*\]\s+/, "\.\. \[#\] ")


# ̤ STDOUT ؽ
print content
